\\ Copyright 2015, 2017, 2019 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ Centroid of boundary segments.

default(recover,0);
read("terdragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}


\\-----------------------------------------------------------------------------

HI_x = 7261/884736*sqrt3
HI_y = 58999/2654208*sqrt3
HI_xy = -449/27648
HI_alpha_fraction = HI_xy / (HI_x - HI_y)
HI_minimum_alpha = 1/2*atan(HI_alpha_fraction)

p = hull_limit * 1.0;
p = apply(z->z-1/2, p);    \\ to centroid at 0,0

\\ rot = exp(-HI_minimum_alpha*I)
\\ p = apply(z->z*rot, p);    \\ to principal axis horizontal

print("vertices");
for(i=1,#p, print(p[i]));

print("inertia");
inertia = geom_inertia_of_polygon(p)

print("area ", geom_area_of_polygon(p));
print("centroid ", geom_centroid_of_polygon(p));
print("determinant ", matdet(inertia));

alpha_min = geom_inertia_principal_xyangle(inertia) + Pi/2;
print("inertia min radians ", alpha_min);
print("inertia min degrees ", to_degrees(alpha_min));
