\\ Copyright 2014, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.



nearly_equal(x,y) = abs(x-y) < 1e-6;
test_equal(x,y,name="") = if(!nearly_equal(x,y),print(name," bad ",x," ",y);quit(1));
deg(x) = x/180*Pi;
nearly(x) = if(type(x)=="t_VEC",apply(nearly,x), \
               my(v=x*16*7); if(nearly_equal(v,round(v)), round(v)/(16*7), x))
asdeg(x) = nearly(x/Pi*180)
atan2(y,x) = my(angle=arg(x+I*y)); if(angle<0,angle+2*Pi,angle);
asin_other(s) = Pi-asin(s);
acos_other(c) = 2*Pi - acos(c);

IMref(alpha) = 5/84*sin(alpha)^2 - 4/84*sin(alpha+deg(30))^2 + 6/168;

IM(alpha) = 5/168 - 5/168*cos(2*alpha) - 2/84 + 2/84*cos(2*alpha+deg(60)) + 6/168;
IM(alpha) = 7/168 - 5/168*cos(2*alpha) + 2/84*cos(2*alpha+deg(60));
IM(alpha) = 7/168 - 5/168*cos(2*alpha) + 2/84*(cos(2*alpha)*cos(deg(60)) - sin(2*alpha)*sin(deg(60)));
IM(alpha) = 7/168 - 5/168*cos(2*alpha) + 1/84*cos(2*alpha) - sqrt(3)/84*sin(2*alpha);
IM(alpha) = 7/168 - 3/168*cos(2*alpha) - sqrt(3)/84*sin(2*alpha);
for(i=0,256,my(alpha=i/256*Pi); test_equal(IMref(alpha), IM(alpha)))

th_ref = atan2((-3/168), (-sqrt(3)/84));
print("th = ",th_ref);
sin(th)/cos(th)

th = atan2(-sqrt(3)/2, -1)
asdeg(th)
test_equal(th,th_ref);

\\ sin(th)^2/cos(th)^2 = 3/4
\\ sin(th)^2/(1-sin(th)^2) = 3/4
\\ sin(th)^2 = 3/4*(1-sin(th)^2)
\\ sin(th)^2 = 3/4 - 3/4*sin(th)^2
\\ sin(th)^2 + 3/4*sin(th)^2 = 3/4
\\ 7/4*sin(th)^2 = 3/4
\\ sin(th)^2 = 3/7
print("t1-4");
t1 = asin(sqrt(3/7))
t2 = asin(-sqrt(3/7))
t3 = asin_other(sqrt(3/7))
t4 = asin_other(-sqrt(3/7))
tan(t1)
tan(t2)
tan(t3)
tan(t4)
th = asin_other(-sqrt(3/7))
test_equal(th,th_ref)

th = arg(-sqrt(3)/84 - 3/168*I) + 2*Pi;
test_equal(th,th_ref);
th = arg(-2 - sqrt(3)*I) + 2*Pi;
test_equal(th,th_ref);

\\ 1/2 - 1/2*cos(2*th) = 3/7
\\ 1/2*cos(2*th) = 1/14
\\ cos(2*th) = 1/7
print("sin^2 = ",nearly(sin(th)^2));
print("cos(2t) = ",nearly(cos(2*th)));

\\ 2*th = +/-acos(1/7)  mod 2pi
\\ th = +/-1/2*acos(1/7)  mod pi
th = 1/2*acos(1/7) + Pi
test_equal(th,th_ref, "th by acos")


IM(alpha) = 7/168 - 3/168/sin(th) *cos(2*alpha)*sin(th) - sqrt(3)/84/cos(th)  *sin(2*alpha)*cos(th);
test_equal(- 3/168/sin(th), - sqrt(3)/84/cos(th))
IM(alpha) = 7/168 - 3/168/sin(th) *(cos(2*alpha)*sin(th) + sin(2*alpha)*cos(th));
IM(alpha) = 7/168 - 3/168/sin(th) *sin(2*alpha + th);
IM(alpha) = 7/168 - 3/168/(-sqrt(3/7)) *sin(2*alpha + 1/2*acos(1/7) + Pi);
IM(alpha) = 7/168 + 1/(8*sqrt(21)) *sin(2*alpha + 1/2*acos(1/7) + Pi);
IM(alpha) = 7/168 + 1/(8*sqrt(21)) *cos(2*alpha + 1/2*acos(1/7) + Pi/2);

\\ sin(t/2)^2 = (1 - cos(t)) / 2
\\ 2*sin(t/2)^2 = 1 - cos(t)
\\ cos(t) = 1 - 2*sin(t/2)^2
IM(alpha) = 7/168 + 1/(8*sqrt(21)) *(1 - 2*sin((2*alpha + 1/2*acos(1/7) + Pi/2)/2)^2);
IM(alpha) = 7/168 + 1/(8*sqrt(21)) *(1 - 2*sin(alpha + 1/4*acos(1/7) + Pi/4)^2);
IM(alpha) = 7/168 + sqrt(21)/168 *(1 - 2*sin(alpha + 1/4*acos(1/7) + Pi/4)^2);
IM(alpha) = 7/168 + sqrt(21)/168 - sqrt(21)/168*2*sin(alpha + 1/4*acos(1/7) + Pi/4)^2;
IM(alpha) = (7 + sqrt(21))/168 - 2*sqrt(21)/168*cos(alpha + 1/4*acos(1/7) + 3*Pi/4)^2;
IM(alpha) = (7 + sqrt(21))/168 - 2*sqrt(21)/168*sin(alpha + 1/4*acos(1/7) + Pi/4)^2;

for(i=0,256,my(alpha=i/256*Pi); test_equal(IMref(alpha), IM(alpha)))
\\ ploth(alpha=0,1,IM(alpha*Pi))
\\ ploth(alpha=.136,.6136,IM(alpha*Pi))
\\ ploth(alpha=.1,.7,IM(alpha*Pi))

\\ min and max when cos=+/-1
\\ max at 2*alpha + 1/2*acos(1/7) = 0
\\        alpha = - 1/4*acos(1/7)
\\ min at 2*alpha + 1/2*acos(1/7) = deg(180)
\\        alpha = deg(90) - 1/4*acos(1/7)





\\ A*sin(alpha)^2 + B*sin(alpha+deg(30))^2
\\ A/2 - A/2*cos(2*alpha) + B/2 - B/2*cos(2*alpha + deg(60))
\\ A/2 + B/2 - A/2*cos(2*alpha) - B/2*(cos(2*alpha)*cos(deg(60)) - sin(2*alpha)*sin(deg(60)))
\\ A/2 + B/2 - A/2*cos(2*alpha) - B/2*(sqrt(3)/2*cos(2*alpha) - 1/2*sin(2*alpha))
\\ A/2 + B/2 - A/2*cos(2*alpha) - B*sqrt(3)/4*cos(2*alpha) + B/4*sin(2*alpha)
\\ (A+B)/2 + B/4*sin(2*alpha) - (A/2 + B*sqrt(3)/4)*cos(2*alpha)

