\\ Copyright 2014, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

check_equal(got,want) =
{
  if(got!=want, print("wrong\n","got\n",got,"\nwant\n",want);
                quit(1),
                print("ok\n"));
}


IMA(k) = 1/84 * (5*9^k + [-5,-3,5,3][(k%4)+1]*3^floor(k/2));
vector(8,k,my(k=k-1); IMA(k))

IMB(k) = 1/84 * (-4*9^k + (-1+5*(-1)^k)*(-3)^floor(k/2));
IMB(k) = 1/84 * (-4*9^k + [4,-6,-4,6][(k%4)+1]*3^floor(k/2));
vector(8,k,my(k=k-1); IMB(k))

den(k) = (IMA(k)^2 + IMA(k)*IMB(k) + IMB(k)^2);
vector(8,k,my(k=k-1); den(k))*4

IMA_squared(k) = 1/84/84 * (25*81^k + ([-50,-30,50,30][(k%4)+1])*9^k*3^floor(k/2) + ([25,3][(k%2)+1])*3^k);
check_equal(vector(256,k,my(k=k-1); IMA_squared(k)), \
            vector(256,k,my(k=k-1); (IMA(k)^2)));

IMB_squared(k) = 1/84/84 * (16*81^k \
                            + ([-32,48,32,-48][(k%4)+1])*9^k*3^floor(k/2) \
                            + ([16,12][(k%2)+1])*3^k);
check_equal(vector(256,k,my(k=k-1); IMB_squared(k)), \
            vector(256,k,my(k=k-1); (IMB(k)^2)));
IMB_squared(k) = 1/84/21*3^k * (4*27^k \
                                + ([-8,12,8,-12][(k%4)+1])*3^k*3^floor(k/2) \
                                + ([4,3][(k%2)+1]));
check_equal(vector(256,k,my(k=k-1); IMB_squared(k)), \
            vector(256,k,my(k=k-1); (IMB(k)^2)));

IMA_IMB(k) = 1/84/84 * (-20*81^k \
                        + 5*9^k * [4,-6,-4,6][(k%4)+1]*3^floor(k/2) \
                        - 4*9^k * [-5,-3,5,3][(k%4)+1]*3^floor(k/2) \
                        + [-5,-3,5,3][(k%4)+1]*3^floor(k/2) * [4,-6,-4,6][(k%4)+1]*3^floor(k/2));
check_equal(vector(256,k,my(k=k-1); IMA_IMB(k)), \
            vector(256,k,my(k=k-1); IMA(k)*IMB(k)));
IMA_IMB(k) = 1/84/84 * (-20*81^k \
                        + [40, -18, -40, 18][(k%4)+1] * 9^k*3^floor(k/2) \
                        + [-20, 6][(k%2)+1]*3^k);
check_equal(vector(256,k,my(k=k-1); IMA_IMB(k)), \
            vector(256,k,my(k=k-1); IMA(k)*IMB(k)));

den(k) = 1/84/84 * (25*81^k \
                    + ([-50,-30,50,30][(k%4)+1])*9^k*3^floor(k/2) \
                    + ([25,3][(k%2)+1])*3^k \
                    + 16*81^k \
                    + 2*-4*([4,-6,-4,6][(k%4)+1])*9^k*3^floor(k/2) \
                    + ([16,12][(k%2)+1])*3^k \
                    + -20*81^k \
                    + 9^k * [40, -18, -40, 18][(k%4)+1]*3^floor(k/2) \
                    + [-20, 6][(k%2)+1]*3^k);
check_equal(vector(256,k,my(k=k-1); den(k)), \
            vector(256,k,my(k=k-1); (IMA(k)^2 + IMA(k)*IMB(k) + IMB(k)^2)));
den(k) = 1/84/4 * 3^k * (27^k \
                         + ([-2,0,2,0][(k%4)+1])*3^k*3^floor(k/2) \
                         + 1);
check_equal(vector(256,k,my(k=k-1); den(k)), \
            vector(256,k,my(k=k-1); (IMA(k)^2 + IMA(k)*IMB(k) + IMB(k)^2)));

CC_ref(k) = -1 + 3/2*IMB(k)^2 / (IMA(k)^2 + IMA(k)*IMB(k) + IMB(k)^2);
CC_ref(10)
CC_ref(100)

CC(k) = -1 + 3/2*1/84/84 * (16*81^k \
                            + ([-32,48,32,-48][(k%4)+1])*9^k*3^floor(k/2) \
                            + ([16,12][(k%2)+1])*3^k) \
       / ( 1/84/4 * 3^k * (27^k \
                         + ([-2,0,2,0][(k%4)+1])*3^k*3^floor(k/2) \
                         + 1) );
check_equal(vector(256,k, CC(k)), \
            vector(256,k, CC_ref(k)));
CC(k) = -1 + 1/7 * (8*27^k \
                            + ([-16, 24, 16, -24][(k%4)+1])*3^k*3^floor(k/2) \
                            + ([8, 6][(k%2)+1])) \
       / ( (27^k \
            + ([-2,0,2,0][(k%4)+1])*3^k*3^floor(k/2) \
            + 1) );
check_equal(vector(256,k, CC(k)), \
            vector(256,k, CC_ref(k)));
CC(k) = 1/7 + 1/7 * (([0, 24, 0, -24][(k%4)+1])*3^k*3^floor(k/2) \
                          + ([0, -2][(k%2)+1]) ) \
       / (27^k \
          + ([-2,0,2,0][(k%4)+1])*3^k*3^floor(k/2) \
          + 1);
check_equal(vector(256,k, CC(k)), \
            vector(256,k, CC_ref(k)));
\\ CC(k) = 1/7 when k even, ->1/7 when k odd

CC(k) = 1/7 - if(k%2==0, 0, \
                 2/7 * (4*3^k*(-3)^ceil(k/2) + 1) / (27^k + 1));
check_equal(vector(256,k, CC(k)), \
            vector(256,k, CC_ref(k)));
\\ CC(k) = 1/7 when k even, ->1/7 when k odd