\\ Copyright 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


default(recover,0);
read("terdragon-defines.gp");

check_count = 0;
check_exact(got,want, name="") =
{
  check_count++;
  if(got!= want,
     print("\nwrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count"  "name));
}


\\-----------------------------------------------------------------------------
\\ increment

\\ vertical when dir(n) odd

dz_to_Sd(dz,d) =
{
  \\ 1/2*(1 + real( dz*(-I)^d ) - abs( imag(dz*(-I)^d) ) );  \\ [1,0,0,0]
  \\ real( dz*(-I)^d );        \\ [1,0,-1,0]
  \\ imag( dz*(-I)^d );        \\ [-1,0,1,0]
  \\ abs(imag(dz*(-I)^d));     \\ [1,0,1,0]
  \\ real(dz*b*(-I)^d);        \\ [1,1, -1,-1]
  \\ 2*real(dz*b*(-I)^d)+2;    \\ [4,4,0,0]
  \\ 2*imag(dz*b*(-I)^d)+2;    \\ [4,0,0,4]
  abs(imag(dz*b*w3^d)+1); \\ [2,0,0,2]
  real(dz*w3^d);       \\ [1, -1/2, -1/2]
  abs(imag(dz*w3^d));  \\ [0, 1/2, 1/2]
  real( dz*w3^d ) + abs( imag(dz*w3^d) );  \\ [1,0,0]
}
vector(3,d,d--; dz_to_Sd(1,d))
vector(3,d,d--; dz_to_Sd(w3,d))
vector(3,d,d--; dz_to_Sd(w3^2,d))
\\ {
\\ print("real ",apply(real, [1,I,-1,-I]));
\\ print("imag ",apply(imag, [1,I,-1,-I]));
\\ apply(dz->dz_to_Sd, [1,I,-1,-I])


\\-----------------------------------------------------------------------------

SN_by_count(n,d) = sum(i=0,n-1, dir(i)%4==d);

SN_by_bits(n,d) =
{
  floor( 1/3*n + real(terdragon_point(n)) - 1/2*real(w3*terdragon_point(n)) - 1/2*real(w3^2*terdragon_point(n)) );
}

{
  for(n=0,50,
     print("n="n
           "  "apply(d->SN_by_bits(n,d),[0,1,2])
           "  "apply(d->SN_by_count(n,d),[0,1,2])
           "  "apply(d->SN_by_bits(n,d)-SN_by_count(n,d),[0,1,2])));
}
quit
